package com.example.demo.common;

import com.alibaba.fastjson2.JSONObject;
import com.alibaba.fastjson2.JSONWriter;
import com.example.demo.entity.constant.RestCode;

public record ResponseBean<T>(int code, T data, String msg) {
    public static <T> ResponseBean<T> success() {
        return new ResponseBean<>(RestCode.SUCCESS.getCode(), null, RestCode.SUCCESS.getMsg());
    }

    public static <T> ResponseBean<T> success(T data) {
        return new ResponseBean<>(RestCode.SUCCESS.getCode(), data, RestCode.SUCCESS.getMsg());
    }

    public static <T> ResponseBean<T> success(T data, String msg) {
        return new ResponseBean<>(RestCode.SUCCESS.getCode(), data, msg);
    }

    public static <T> ResponseBean<T> success(String msg) {
        return new ResponseBean<>(RestCode.SUCCESS.getCode(), null, msg);
    }

    public static <T> ResponseBean<T> failure() {
        return new ResponseBean<>(RestCode.ERROR.getCode(), null, RestCode.ERROR.getMsg());
    }

    public static <T> ResponseBean<T> failure(T data) {
        return new ResponseBean<>(RestCode.ERROR.getCode(), null, RestCode.ERROR.getMsg());
    }

    public static <T> ResponseBean<T> failure(String msg) {
        return new ResponseBean<>(RestCode.ERROR.getCode(), null, msg);
    }

    public static <T> ResponseBean<T> failure(T data, String msg) {
        return new ResponseBean<>(RestCode.ERROR.getCode(), data, msg);
    }


    public static <T> ResponseBean<T> failure(RestCode code) {
        return new ResponseBean<>(code.getCode(), null, code.getMsg());
    }

    public static <T> ResponseBean<T> failure(RestCode code, String msg) {
        return new ResponseBean<>(code.getCode(), null, msg);
    }

    public static <T> ResponseBean<T> failure(RestCode code, T data) {
        return new ResponseBean<>(code.getCode(), data, code.getMsg());
    }

    public static <T> ResponseBean<T> failure(RestCode code, T data, String msg) {
        return new ResponseBean<>(code.getCode(), data, msg);
    }

    public String toJsonString() {
        return JSONObject.toJSONString(this, JSONWriter.Feature.WriteNulls);
    }
}
